ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.9 by root, Tue Dec 7 20:03:15 2010 UTC vs.
Revision 1.18 by root, Mon Dec 13 16:34:13 2010 UTC

2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10MKBUNDLE="$STATICPERL/mkbundle"
11
12# perl build variables 10# perl build variables
13PERL_PREFIX="$STATICPERL/perl" # where the perl gets installed
14PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 11PERL_VERSION=5.12.2 # 5.8.9 is also a good choice
15PERL_CONFIGURE="" # additional Configure arguments 12PERL_CONFIGURE="" # additional Configure arguments
16PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 13PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP"
17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 14PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
18 15
19ARCH="$(uname -m)" 16ARCH="$(uname -m)"
20 17
21case "$ARCH" in 18case "$ARCH" in
22 i*86 | x86_64 | amd64 ) 19 i*86 | x86_64 | amd64 )
23 PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64 20 #PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64
21 PERL_OPTIMIZE="$PERL_OPTIMIZE" # x86/amd64
24 case "$ARCH" in 22 case "$ARCH" in
25 i*86 ) 23 i*86 )
26 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only 24 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only
27 ;; 25 ;;
28 esac 26 esac
29 ;; 27 ;;
30esac 28esac
31 29
32# -Wl,--gc-sections makes it impossible to check for undefined references 30# -Wl,--gc-sections makes it impossible to check for undefined references
33# for some reason so we need to patch away the "-no" after Configure and before make :/ 31# for some reason so we need to patch away the "-no" after Configure and before make :/
34# -z muldefs is to work around uclibc's pthread static linking bug 32# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
35PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 33PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 34PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
37 35
38# some configuration options for modules 36# some configuration options for modules
39export PERL_MM_USE_DEFAULT=1 37export PERL_MM_USE_DEFAULT=1
40#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 38#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
52postconfigure() { : ; } 50postconfigure() { : ; }
53postbuild() { : ; } 51postbuild() { : ; }
54postinstall() { : ; } 52postinstall() { : ; }
55 53
56# now source user config, if any 54# now source user config, if any
55if [ "$STATICPERLRC" ]; then
56 . "$STATICPERLRC"
57else
57[ -r /etc/staticperlrc ] && . /etc/staticperlrc 58 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
58[ -r ~/.staticperlrc ] && . ~/.staticperlrc 59 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
59[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 60 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
61fi
60 62
61############################################################################# 63#############################################################################
62# support 64# support
65
66MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
67PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
68
69unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
70export LC_ALL=C # just to be on the safe side
63 71
64# set version in a way that Makefile.PL can extract 72# set version in a way that Makefile.PL can extract
65VERSION=VERSION; eval \ 73VERSION=VERSION; eval \
66$VERSION=0.1 74$VERSION=0.911
67 75
68BZ2=bz2 76BZ2=bz2
69BZIP2=bzip2 77BZIP2=bzip2
70 78
71fatal() { 79fatal() {
104############################################################################# 112#############################################################################
105# clean 113# clean
106 114
107distclean() { 115distclean() {
108 verblock <<EOF 116 verblock <<EOF
109deleting everything installed by this script 117 deleting everything installed by this script (rm -rf $STATICPERL)
110EOF 118EOF
111 119
112 rm -rf "$STATICPERL" 120 rm -rf "$STATICPERL"
113} 121}
114 122
147 verblock <<EOF 155 verblock <<EOF
148unpacking perl 156unpacking perl
149EOF 157EOF
150 158
151 mkdir -p unpack 159 mkdir -p unpack
152 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xC unpack \ 160 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \
153 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 161 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking"
154 chmod -R u+w unpack/perl-$PERL_VERSION 162 chmod -R u+w unpack/perl-$PERL_VERSION
155 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 163 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
156 rmdir -p unpack 164 rmdir -p unpack
157 fi 165 fi
254 verblock <<EOF 262 verblock <<EOF
255installing $STATICPERL/src/perl-$PERL_VERSION 263installing $STATICPERL/src/perl-$PERL_VERSION
256to $PERL_PREFIX 264to $PERL_PREFIX
257EOF 265EOF
258 266
259 rm -rf "$PERL_PREFIX" 267 ln -sf "perl/bin/" "$STATICPERL/bin"
260 268 ln -sf "perl/lib/" "$STATICPERL/lib"
269
270 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
271 rm -rf "$PERL_PREFIX" # by this rm -rf
272
261 make install || fatal "make install: error while installing" 273 make install || fatal "make install: error while installing"
262 274
263 rcd "$PERL_PREFIX" 275 rcd "$PERL_PREFIX"
264 276
265 # create a "make install" replacement for CPAN 277 # create a "make install" replacement for CPAN
266 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 278 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
267make install UNINST=1 279make || exit
280
268if find blib/arch/auto -type f | grep -q -v .exists; then 281if find blib/arch/auto -type f | grep -q -v .exists; then
269 echo Probably an XS module, rebuilding perl 282 echo Probably an XS module, rebuilding perl
270 make perl 283 if make perl; then
271 rm -f "$PERL_PREFIX"/bin/perl 284 mv perl "$PERL_PREFIX"/bin/perl
272 make -f Makefile.aperl inst_perl
273 make -f Makefile.aperl map_clean 285 make -f Makefile.aperl map_clean
286 else
287 make -f Makefile.aperl map_clean
288 exit 1
289 fi
274fi 290fi
291
292make install UNINST=1
275EOF 293EOF
276 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install 294 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
277 295
278 # trick CPAN into avoiding ~/.cpan completely 296 # trick CPAN into avoiding ~/.cpan completely
279 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 297 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
294 ' || fatal "error while initialising CPAN" 312 ' || fatal "error while initialising CPAN"
295 313
296 touch "$PERL_PREFIX/staticstamp.install" 314 touch "$PERL_PREFIX/staticstamp.install"
297 fi 315 fi
298 316
299 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall"; then 317 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
300 NOCHECK_INSTALL=+ 318 NOCHECK_INSTALL=+
301 instcpan $STATICPERL_MODULES 319 instcpan $STATICPERL_MODULES
302 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 320 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
303 321
304 postinstall || fatal "postinstall hook failed" 322 postinstall || fatal "postinstall hook failed"
355############################################################################# 373#############################################################################
356# main 374# main
357 375
358podusage() { 376podusage() {
359 echo 377 echo
378
360 if [ -e "$PERL_PREFIX/bin/perl" ]; then 379 if [ -e "$PERL_PREFIX/bin/perl" ]; then
361 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \ 380 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
362 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 381 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
363 2>/dev/null && exit 382 2>/dev/null && exit
364 fi 383 fi
384
365 # try whatever perl we can find 385 # try whatever perl we can find
366 perl -MPod::Usage -e \ 386 perl -MPod::Usage -e \
367 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 387 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
368 2>/dev/null && exit 388 2>/dev/null && exit
369 389
370 fatal "displaying documentation requires a working perl - try '$0 install' first" 390 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
371} 391}
372 392
373usage() { 393usage() {
374 podusage 0 394 podusage 0
375} 395}
385} 405}
386 406
387bundle() { 407bundle() {
388 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 408 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
389 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 409 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
410 CACHE="$STATICPERL/cache"
411 mkdir -p "$CACHE"
390 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 412 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
391} 413}
392 414
393if [ $# -gt 0 ]; then 415if [ $# -gt 0 ]; then
394 while [ $# -gt 0 ]; do 416 while [ $# -gt 0 ]; do
395 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 417 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
396 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create" 418 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
397 419
398 command="${1#--}"; shift 420 command="${1#--}"; shift
399 case "$command" in 421 case "$command" in
422 version )
423 echo "staticperl version $VERSION"
424 ;;
400 fetch | configure | build | install | clean | distclean) 425 fetch | configure | build | install | clean | distclean)
401 verblock <<EOF
402$command
403EOF
404 ( "$command" ) 426 ( "$command" )
405 ;; 427 ;;
406 instsrc ) 428 instsrc )
407 ( instsrc "$@" ) 429 ( instsrc "$@" )
408 exit 430 exit
422 exit 444 exit
423 ;; 445 ;;
424 mkperl ) 446 mkperl )
425 ( install ) 447 ( install )
426 bundle --perl "$@" 448 bundle --perl "$@"
449 exit
450 ;;
451 mkapp )
452 ( install )
453 bundle --app "$@"
427 exit 454 exit
428 ;; 455 ;;
429 help ) 456 help )
430 podusage 2 457 podusage 2
431 ;; 458 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines